/* 
 Joan Soler-Adillon
 Realitat Virtual || Realidad Virtual - Processing
 Màster en Arts Digitals, UPF
 http://www.joan.cat/
 */

int total = 500;
cosa[] cosasList = new cosa[total];
//declaramos variables
PVector gravedad;
//creamos 1 atractor
attractor att;

void setup() {

  size(500, 200);
  att = new attractor(width/2, height/2, true, 8);
  //inicializamos variables
  gravedad = new PVector(0, 0.01);
  for (int i=0; i<total; i++) {
    cosasList[i] = new cosa();
  }
}

void draw() {
  background(0);
  for (cosa c : cosasList) {
    c.addForce(att.getForce(c.posicion));
    PVector grav = gravedad.get();
    grav.mult(c.myMass);
    c.run();
  }
}
////////////////////////////////////////////////////////////////////
/////////// CLASE ATRACTOR
////////////////////////////////////////////////////////////////////////
class attractor {

  PVector pos;
  float factor;
  boolean divider;

  attractor(float _x, float _y, boolean _divider, float _factor) {
    pos = new PVector(_x, _y);
    factor = _factor;
    divider = _divider;
  }

  PVector getForce(PVector _victimPos) {
    PVector distanceVector = PVector.sub(pos, _victimPos);
    if (divider) {
      distanceVector.div(factor);
    } 
    else {
      distanceVector.normalize();
      distanceVector.mult(factor);
    }
    return distanceVector;
  }
}

////////////////////////////////////////////////////////////////////
/////////// CLASE COSA
////////////////////////////////////////////////////////////////////////
class cosa {

  PVector posicion, velocidad, acceleracion;
  float frictionScaleFactor, mySizeMax, mySizeMin, mySize, myMass;

  cosa() {
    posicion = new PVector(random(width), random(5, 60));
    velocidad = new PVector(0, 0);
    acceleracion = new PVector(0, 0);
    mySizeMin = 10;
    mySizeMax = 25;
    mySize = random(mySizeMin, mySizeMax);
    myMass = map(mySize, mySizeMin, mySizeMax, 1, 2);
    frictionScaleFactor = 1.2;//mayor a 1 mejor
  }

  void run() {
    update();
    drawMe();
  }

  void update() {  
    //Añadimos el valor de gravedad (aceleración) a la velocidadocidad y velocidadocidad a posicionición
    velocidad.add(acceleracion);
    velocidad.limit(10);
    posicion.add(velocidad);
    acceleracion.mult(0);

    //comprobamo los bordes de la ventana
    //en lo horizontal, como siempre
    if (posicion.x < mySize/2) {
      velocidad.x *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      posicion.x = mySize/2;
    } 
    else if (posicion.x > width-mySize/2) {
      velocidad.x *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      posicion.x = width-mySize/2;
    }
    //pero en lo vertical sólo abajo, y reduciendo cada vez la velocidadocidad, para simular fricción.

    if (posicion.y > height-mySize/2) {//||(posicion.y < 0)) {
      velocidad.y *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      //para que no se enganche:
      posicion.y = height-mySize/2;
    } 
    else if (posicion.y - mySize/2 < 0) {
      velocidad.y *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      //para que no se enganche:
      posicion.y = mySize/2;
    }
  }

  void drawMe() {
    //y finalmente, dibujamos
    ellipse(posicion.x, posicion.y, mySize, mySize);
  }

  void addForce(PVector _f) {
    PVector f = PVector.div(_f, myMass);
    acceleracion.add(f);//.add(f);
  }
}

