/* 
 Joan Soler-Adillon
 Realitat Virtual || Realidad Virtual - Processing
 Màster en Arts Digitals, UPF
 http://www.joan.cat/
 */

int total = 1000;
ArrayList tractores = new ArrayList();
cosa[] cosasList = new cosa[total];
float maxFactor = 1000, minFactor = 50;

//declaramos variables
PVector gravedad, wind;

void setup() {
  
  noSmooth();
  size(500, 200);
  //inicializamos variables
  gravedad = new PVector(0, 0.05);
  wind = new PVector(0, 0);
  for (int i=0; i<total; i++) {
    cosasList[i] = new cosa();
  }
}

void draw() {
  background(0);
      fill(255,50);
    //stroke(0);
    noStroke();
  for (cosa c : cosasList) {
    for (int i=0; i<tractores.size();i++) {
      attractor a = (attractor) tractores.get(i);
      c.addForce(a.getForce(c.posicion));
    }
    PVector grav = gravedad.get();
    grav.mult(c.myMass);
    c.addForce(grav);
    c.run();
  }
  noFill();
  for (int i=0; i<tractores.size();i++) {
    attractor a = (attractor) tractores.get(i);
    stroke(255, 0, 0, 127);
    a.run();
    ellipse(a.pos.x, a.pos.y, map(a.factor,maxFactor,minFactor,5,30),map(a.factor,maxFactor,minFactor,5,30));
  }
}

void mousePressed() {
  attractor att = new attractor(mouseX, mouseY, true, random(60, maxFactor));
  tractores.add(att);
}

////////////////////////////////////////////////////////////////////
/////////// CLASE ATRACTOR
////////////////////////////////////////////////////////////////////////
class attractor {

  PVector pos;
  float factor;
  boolean divider;

  attractor(float _x, float _y, boolean _divider, float _factor) {
    pos = new PVector(_x, _y);
    factor = _factor;
    divider = _divider;
  }

  void run(){
    float step = 5;
    int killLimit = 25;
   pos.x += random(-step,step);
    pos.y += random(-step,step);
    if(pos.x < killLimit || pos.x > width-killLimit || pos.y < killLimit || pos.y > height-killLimit){
      tractores.remove(this); 
    }
    //pos.y = constrain( pos.y,0,width);
    //pos.x = constrain( pos.x,0,width);

  }
 
 
  PVector getForce(PVector _victimPos) {
    PVector distanceVector = PVector.sub(pos, _victimPos);
    if (divider) {
      distanceVector.div(factor);
    } 
    else {
      distanceVector.normalize();
      distanceVector.mult(factor);
    }
    return distanceVector;
  }
}

////////////////////////////////////////////////////////////////////
/////////// CLASE COSA
////////////////////////////////////////////////////////////////////////
class cosa {

  PVector posicion, velocidad, acceleracion;
  float frictionScaleFactor, mySizeMax, mySizeMin, mySize, myMass;

  cosa() {
    posicion = new PVector(random(width), random(5, 60));
    velocidad = new PVector(0, 0);
    acceleracion = new PVector(0, 0);
    mySizeMin = 2;
    mySizeMax = 10;
    mySize = random(mySizeMin, mySizeMax);
    myMass = map(mySize, mySizeMin, mySizeMax, 1, 2);
    frictionScaleFactor = 1.2;//mayor a 1 mejor
  }

  void run() {
    update();
    drawMe();
  }

  void update() {  
    //Añadimos el valor de gravedad (aceleración) a la velocidadocidad y velocidadocidad a posicionición
    velocidad.add(acceleracion);
    velocidad.limit(10);
    posicion.add(velocidad);
    acceleracion.mult(0);

    //comprobamo los bordes de la ventana
    //en lo horizontal, como siempre
    if (posicion.x < mySize/2) {
      velocidad.x *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      posicion.x = mySize/2;
    } 
    else if (posicion.x > width-mySize/2) {
      velocidad.x *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      posicion.x = width-mySize/2;
    }
    //pero en lo vertical sólo abajo, y reduciendo cada vez la velocidadocidad, para simular fricción.

    if (posicion.y > height-mySize/2) {//||(posicion.y < 0)) {
      velocidad.y *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      //para que no se enganche:
      posicion.y = height-mySize/2;
    } 
    else if (posicion.y - mySize/2 < 0) {
      velocidad.y *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      //para que no se enganche:
      posicion.y = mySize/2;
    }
  }

  void drawMe() {
    //y finalmente, dibujamos

    ellipse(posicion.x, posicion.y, mySize, mySize);
  }

  void addForce(PVector _f) {
    PVector f = PVector.div(_f, myMass);
    acceleracion.add(f);//.add(f);
  }
}

